//! When events happen to datamaps
use super::*;

/// What happened in the event
#[derive(Debug, Serialize, Deserialize)]
pub enum EventKind
{
    Created,
    Modified,
    Deleted,

    Renamed(String), // Previous name
    Cloned(data::AbsoluteIndex), // Index of the new item
    Moved,

    Comment(String),
}

/// An event that happened to a data entry
#[derive(Debug, Serialize, Deserialize)]
pub struct Event
{
    who: Option<user::UserID>,
    what: EventKind,
    when: u64,

    signed: Option<cryptohelpers::rsa::Signature>,
}
